Package: clusterStab
Title: Compute cluster stability scores for microarray data
Version: 1.84.0
Author: James W. MacDonald, Debashis Ghosh, Mark Smolkin
Description: This package can be used to estimate the number of clusters
	in a set of microarray data, as well as test the stability of these
	clusters.
Maintainer: James W. MacDonald <jmacdon@u.washington.edu>
License: Artistic-2.0
Depends: Biobase (>= 1.4.22), R (>= 1.9.0), methods
Suggests: fibroEset, genefilter
LazyLoad: True
biocViews: Clustering
git_url: https://git.bioconductor.org/packages/clusterStab
git_branch: RELEASE_3_23
git_last_commit: 496ee81
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:17:19 UTC; biocbuild

setMethod("benhur", "matrix", function(object, freq, upper, seednum = NULL, linkmeth = "average",
                                       distmeth = "euclidean", iterations = 100){

  do.benhur(object, freq, upper, seednum = seednum, linkmeth = linkmeth,
            iterations = iterations)
})

setMethod("benhur", "ExpressionSet", function(object, freq, upper, seednum = NULL,
                                              linkmeth = "average", distmeth = "euclidean",
                                              iterations = 100){

  object <- exprs(object)
  do.benhur(object, freq, upper, seednum = seednum, linkmeth = linkmeth,
            distmeth = distmeth, iterations = iterations)
})


## Show method for benhur


setMethod("show","BenHur",
          function(object){
            cat("A BenHur object\n")
            cat("produced using", object@iterations, "iterations and\n")
            cat("a ", object@freq * 100, "% subsampling frequency,\n", sep="")
            cat("testing for clusters <=", length(object@jaccards) + 1,"\n")
          })

## Define a generic for plotting jaccards


setMethod("hist", "BenHur",
          function(x, ...){
            ## Set up graphics device
            oldpar <- par(no.readonly = TRUE)
            par(mfrow=c(x@size,4))

            dat <- x@jaccards
            xlim <- range(hist(dat[[length(dat)]], 25, plot = FALSE)$breaks)
            for(i in seq(along=dat)){
              hist(dat[[i]], 25, freq = TRUE, main=paste("k = ", i + 1), ylab = "",
                   xlab = "Frequency", xlim = xlim)
            }
            par(oldpar)
          })

## Define a generic for plotting jaccardmatrix


setMethod("ecdf", "BenHur",
          function(x){
            seqvec <- seq(1/x@iterations, 1, by = 1/x@iterations)
            dat <- x@jaccards
            ## Make sure all jaccards are of the same length
            if(all(x@iterations == sapply(dat, length))){
              for (i in 1:length(dat)){
                plot(sort(dat[[i]]), seqvec, type = "s", cex = 0.1, xlim = c(0, 1), ylim = c(0, 1),
                     ylab = "cumulative", xlab = "similarity", col = i)
                par(new = TRUE)
              }
              legend(0, 1, legend = 2:(length(dat) + 1), lty = 1, col = 1:length(dat),
                     title = "Clusters")
              par(new = FALSE)

            }else{
              stop("There are too few samples to produce a cdf plot.\n",
                   "Only the histograms can be plotted.\n")

            }
          })

## Class for benhur object

setClass("BenHur", representation(jaccards = "list",
                                  size = "vector",
                                  iterations  = "vector",
                                  freq = "vector"),
         prototype = list(jaccards = list(),
           size = vector(), iterations = vector(),
           freq = vector()))

## Define a class for clusterComp

setClass("ClusterComp", representation(clusters = "vector",
                                       percent = "vector",
                                       freq = "vector",
                                       clusternum = "vector",
                                       iterations = "vector",
                                       method = "vector"),
         prototype = list(clusters = vector(), percent = vector(),
           freq = vector(), clusternum = vector(), iterations = vector(),
           method = vector()))

############################################################3
##
## James W. MacDonald - 2005
##
##  clusterStab - Functions to estimate sample clusters and to
##                determine the stability of clusters in microarray data
##
## Modifications:
##
## 1-5-05 Cleaned up the original code and optimized for speed.
## 3-22-05 Added  S4 classes benhur and clusterComp, as well as methods for them.
## 2-28-05 Improved computation for Cone and Ctwo
## 6-13-05 Modified do.clusterComp to assess individual cluster stability
##         instead of overall cluster stability as before. In addition, added
##         the adjusted score calculation to account for cluster size.
##
####################################################################






###############################################################################################
##
## benhur - a function to estimate the number of sample clusters for microarray data, based on the methods in
## A. Ben-Hur, A. Elisseeff and I. Guyon. A stability based method for discovering structure in clustered data.
## Pacific Symposium on Biocomputing, 2002.
##
## Originally written by Mark Smolkin <marksmolkin@hotmail.com> further modifications by James W. MacDonald
## <jmacdon@med.umich.edu>
##
## Inputs:
##
## object - a matrix of data where columns are samples and rows are genes. These data should already be normalized
##
## freq - the proportion of samples to use. This value should exceed 0.5 (and of course be less than 1).
##
## upper - the upper limit for the number of clusters.
##
## seednum - an integer used to set the seed. This allows for an exact reproduction of the analysis at a later date.
##
## linkmeth - the linkage method to use for clustering. Valid values include "average", "centroid", "ward", "single",
##            "mcquitty", or "median".
##
## iterations - the number of subsamplings to perform.
##
##
## Output:
##
## An object of class benhur.
##
##
################################################################################################

do.benhur <- function(object, freq , upper, seednum = NULL,
                      linkmeth = "average",  distmeth = "euclidean",
                      iterations = 100){

  if(!is.null(seednum))
    set.seed(seednum)
  require(stats, quietly = TRUE)

  ## Microarray data is usually samples in columns, genes in rows, so we must transpose
  dat <- t(object)
  size <- ceiling((upper-1)/4)
  samples <- dim(dat)[1]
  n <- dim(dat)[2]

  jaccardmatrix <- NULL


  ## Make a list to hold jaccard matrices

  jaccards <- vector("list", length = (upper - 1))


  for(m in 1:iterations){
    sampleone <- sample(1:samples, freq*samples, replace = FALSE)
    sampletwo <- sample(1:samples, freq*samples, replace = FALSE)

    subone <- dat[sampleone,]
    subtwo <- dat[sampletwo,]



    clustone <- hclust(makeDist(subone, distmeth), method = linkmeth)
    clusttwo <- hclust(makeDist(subtwo, distmeth), method = linkmeth)


    ##Checking for intersection

    inboth <- sampleone[sampleone %in% sampletwo]


    for(k in 2:upper){

      ## Cut the trees

      cutone <- cutree(clustone, k)
      cuttwo <- cutree(clusttwo, k)

      ## Cluster membership for intersecting samples

      ord <- 1:length(sampleone)

      placeone <- cutone[ord[match(inboth, sampleone)]]
      placetwo <- cuttwo[ord[match(inboth, sampletwo)]]


      ## This code forms the 'C' matrices s.t. Cij = 1 if xi and xj belong to the same cluster
      ## and i and j are not equal. Cij = 0 otherwise

      m.dim <- length(placeone)
      Cone <- matrix(placeone, nr = m.dim, nc = m.dim) == matrix(placeone, nr = m.dim, nc = m.dim, byrow = TRUE)
      Ctwo <- matrix(placetwo, nr = m.dim, nc = m.dim) == matrix(placetwo, nr = m.dim, nc = m.dim, byrow = TRUE)
      diag(Cone) <- diag(Ctwo) <- 0

      jaccard <- sum(Cone * Ctwo)/(sum(Cone) + sum(Ctwo) - sum(Cone * Ctwo))
      jaccards[[(k-1)]] <- c(jaccards[[(k-1)]], jaccard)
    }
  }

  ## There is a chance that some of the jaccard matrices consist of all ones, which will result
  ## in a histogram that is just a big box. To account for this possibility, we adjust the first value by 0.00001

  jac.test <- lapply(lapply(jaccards, function(x) table(x)), function(y) length(y)) == 1
  if(any(jac.test)){
    fix.jacs <- which(jac.test)
    for(i in fix.jacs)
      jaccards[[i]][[1]] <- jaccards[[i]][[1]] - 0.0001
  }

  ans <- new("BenHur", jaccards = jaccards, size = size, iterations = iterations,
             freq = freq)
  ans
}




########################################################################################
##
## clusterComp - A function to compute stability of clusters based on subsampling as described
##  in  Smolkin, M. and Ghosh, D. (2003).  Cluster stability scores for microarray data in
##  cancer studies . BMC Bioinformatics 4, 36 - 42.
##
## Copyright James W. MacDonald, 2005, all rights reserved
##
##
## Inputs:
##
## object - a matrix of expression data where columns are samples and rows are genes
##
## cl - the number of clusters
##
## seednum - an integer value used to set the random seed.http://svnbook.red-bean.com/svnbook-1.1/svn-book.html#svn-ch-9
##
## B - the number of iterations to perform
##
## sub.frac - the fraction of genes to use in each subsampling. Recommended values are between 0.75 and 0.85
##
## method - the agglomeration method to use. Choices include "ward", "single", "average", "complete", "mcquitty",
##          "median", or "centroid". See ?hclust for more information.
##
## Output:
##
## A list containing:
##
## Clusters - a vector identifying the cluster membership of each sample
##
## Percent - the percentage of subsampled clusters that were identical to the original cluster
##
## Clusternumber - the number of clusters
##
## Genesused - the fraction of genes used for each subsampling
##
##
##
#############################################################################################

do.clusterComp <- function(object, cl, seednum = NULL, B = 100,
                           sub.frac = 0.8, method = "ave",
                           distmeth = "euclidean",
                           adj.score = FALSE){

  if(!is.null(seednum))
    set.seed(seednum)

  methods <-  c("ward", "single", "complete", "average", "mcquitty", 
        "median", "centroid")

   ## Make sure cl is an integer

  if(length(cl) != 1 || !is.numeric(cl))
    stop("The cl argument should only be a single number!")

  ## Get original cluster memberships 
  orig.clust <- hclust(makeDist(t(object), method = distmeth),
                       method = method)
  orig.memb <- cutree(orig.clust, cl)
  memb.list <- vector("list", length=cl)
  for(i in 1:cl)
    memb.list[[i]] <- which(orig.memb == i)

  ## Subsample and output cluster memberships in a matrix

  len <- dim(object)[1]
  count <- vector("list", cl)
  cnt <- 0
  while(cnt < B){
    index <- sample(1:len, sub.frac * len, replace = FALSE)
    tmp <- hclust(makeDist(t(object[index,]), method = distmeth),
                  method = method)
    memb <- cutree(tmp, cl)
    for(i in 1:cl){
      tst <- all(memb[memb.list[[i]]] == i)
      count[[i]] <- c(count[[i]], tst)
    }
    cnt <- cnt + 1
  }
  if(adj.score){
    sizes <- lapply(memb.list, function(x) 1/(log(length(x)) + 1))
    sc.adj <- function(x, y) ((sum(x)/B)^y)*100
    percent <- mapply(sc.adj, count, sizes)
    }else{
      percent <- sapply(count, function(x) sum(x)*100/B)
    }
  ans <- new("ClusterComp", clusters = orig.memb, percent = round(percent,2),
             freq = sub.frac, clusternum = cl, iterations = B,
             method = match.arg(method, methods))
  ans
}



makeDist <- function(dat, method = c("euclidean","pearson")){
    method <- match.arg(method)
    out <- switch(method,
                  pearson = as.dist(1-cor(t(dat))),
                  euclidean = dist(dat))
    out
}
    

setGeneric("benhur", function(object, ...) standardGeneric("benhur"))
setGeneric("clusterComp", function(object, ...) standardGeneric("clusterComp"))
##setGeneric("show", function(object) standardGeneric("show"))
setGeneric("hist", function(x, ...) standardGeneric("hist"))
setGeneric("ecdf", function(x) standardGeneric("ecdf"))

setMethod("clusterComp", "matrix", function(object, cl, seednum = NULL, B = 100,
                                            sub.frac = 0.8, method = "ave",
                                            distmeth = "euclidean", adj.score = FALSE){

  do.clusterComp(object, cl, seednum = seednum, B = B, sub.frac = sub.frac,
                 method = method, distmeth = distmeth,
                 adj.score = adj.score)
})

setMethod("clusterComp", "ExpressionSet", function(object, cl, seednum = NULL, B = 100,
                                             sub.frac = 0.8, method = "ave",
                                                   distmeth = "euclidean", adj.score = FALSE){

  object <- exprs(object)
  do.clusterComp(object, cl, seednum = seednum, B = B, sub.frac = sub.frac,
                 method = method, distmeth = distmeth,
                 adj.score = adj.score)
})

## Show method

setMethod("show","ClusterComp",
          function(object){
            stab.out <- matrix(paste(round(object@percent, 0), "%", sep=""), nr = 1)
            dimnames(stab.out) <- list("Cluster stability: ", 1:length(object@percent))
            cat("Results from running clusterComp:\n")
            print(stab.out, quote = FALSE)
            cat("Iterations:", object@iterations, "\n")
            cat("Subsampling frequency: ", object@freq * 100, "%\n", sep="")
            cat("Agglomeration method:", object@method, "\n")
            cat("Original cluster membership:\n", object@clusters,"\n")
          })

\name{ClusterComp-class}
\docType{class}
\alias{ClusterComp-class}
\alias{show,ClusterComp-method}

\title{Class "ClusterComp" a class for testing the stability of clusters
in microarray data}
\description{A specialized class representation used for testing the
  stability of clusters in microarray data.}
\section{Objects from the Class}{
Objects are usually created by a call to \code{clusterComp}, although
technically objects can be created by calls of the form
\code{new("ClusterComp", ...)}. However, the latter is probably not
worth doing.

}
\section{Slots}{
  \describe{
    \item{\code{clusters}:}{Object of class \code{"vector"} showing the
      cluster membership for each sample when using all the data. }
    \item{\code{percent}:}{Object of class \code{"vector"} containing
      the percentage of subsamples that resulted in the same class
      membership for all samples. }
    \item{\code{freq}:}{Object of class \code{"vector"} containing the
      subsampling percentage used. Defaults to 0.8. }
    \item{\code{clusternum}:}{Object of class \code{"vector"} containing
      the number of clusters tested.}
    \item{\code{iterations}:}{Object of class \code{"vector"} containing
    the number of iterations performed. Defaults to 100.}
    \item{\code{method}:}{Object of class \code{"vector"} containing the
      agglomerative method used. Options include "average", "centroid",
      "ward", "single", "mcquitty", or "median".}
  }
}
\section{Methods}{
  \describe{
    \item{show}{\code{signature(object = "ClusterComp")}: Give a nice
      summary of results. }
  }
}
\references{  A. Ben-Hur, A. Elisseeff and I. Guyon. A stability based
  method for discovering structure in clustered data. Pacific Symposium
  on Biocomputing, 2002.
  Smolkin, M. and Ghosh, D. (2003).  Cluster stability scores for
  microarray data in cancer studies.
  BMC Bioinformatics 4, 36 - 42.
}
\author{James W. MacDonald <jmacdon@u.washington.edu> }
\keyword{classes}

\name{benhur}
\docType{methods}
\alias{benhur}
\alias{do.benhur}
\alias{benhur-methods}
\alias{benhur,matrix-method}
\alias{benhur,ExpressionSet-method}

\title{A Function to Estimate the Number of Clusters in Microarray Data }
\description{
 This function estimates the number of clusters in e.g., microarray data
 using an iterative process proposed by Asa Ben-Hur.
}
\usage{
\S4method{benhur}{ExpressionSet}(object, freq, upper, seednum = NULL,
linkmeth = "average", distmeth = "euclidean", iterations = 100)
\S4method{benhur}{matrix}(object, freq, upper, seednum = NULL, linkmeth
= "average", distmeth = "euclidean", iterations = 100)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{Either a matrix or \code{ExpressionSet} }
  \item{freq}{ The proportion of samples to use. This should be
    somewhere between 0.6 - 0.8 for best results.}
  \item{upper}{ The upper limit for number of clusters.}
  \item{seednum}{A value to pass to \code{set.seed}, which will allow
    for exact reproducibility at a later date.}
  \item{linkmeth}{Linkage method to pass to \code{hclust}. Valid values
    include "average", "centroid", "ward", "single", "mcquitty", or
    "median".}
  \item{distmeth}{The distance method to use. Valid values include
    "euclidean" and "pearson" where pearson implies 1-pearson correlation.}
  \item{iterations}{The number of iterations to use. The default of 100 is a
    reasonable number. }
}
\details{
  This function may be used to estimate the number of true clusters that
  exist in a set of microarray data. This estimate can be used to as
  input for \code{clusterComp} to estimate the stability of the clusters.

  The primary output from this function is a set of histograms that show
  for each cluster size how often similar clusters are formed from
  subsets of the data. As the number of clusters increases, the pairwise
  similarity of cluster membership will decrease. The basic idea is to
  choose the histogram corresponding to the largest number of clusters
  in which the majority of the data in the histogram is concentrated at
  or near 1.

  If overlay is set to \code{TRUE}, an additional CDF plot will be
  produced. This can be used in conjunction with the histograms to
  determine at which cluster number the data are no longer concentrated
  at or near 1.
}
\value{
  
  The output from this function is an object of class \code{benhur}. See
  the \code{benhur-class} man page for more information.
  
}
\references{ A. Ben-Hur, A. Elisseeff and I. Guyon. A stability based
  method for discovering structure in clustered data. Pacific Symposium
  on Biocomputing, 2002.
  Smolkin, M. and Ghosh, D. (2003).  Cluster stability scores for
  microarray data in cancer studies . BMC Bioinformatics 4, 36 - 42.
}
\author{Originally written by Mark Smolkin <marksmolkin@hotmail.com>
  further modifications by James W. MacDonald <jmacdon@u.washington.edu>}

\examples{
data(sample.ExpressionSet)
tmp <- benhur(sample.ExpressionSet, 0.7, 5)
hist(tmp)
ecdf(tmp)
}
\keyword{ hplot }% at least one, from doc/KEYWORDS
\keyword{ cluster }% __ONLY ONE__ keyword per line

\name{BenHur-class}
\docType{class}
\alias{BenHur-class}
\alias{ecdf,BenHur-method}
\alias{hist,BenHur-method}
\alias{show,BenHur-method}

\title{Class "BenHur", a class for estimating clusters in microarray
  data, and methods for visualizing them.}
\description{A specialized class representation used for estimating
  clusters in microarray data.}
\section{Objects from the Class}{
Objects are usually created by a call to \code{benhur}, although
technically a new object can also be created by a call to
\code{new("BenHur",...)}. However, this second method is usually not
worth the work required.
}
\section{Slots}{
  \describe{
    \item{\code{jaccards}:}{Object of class \code{"list"}, containing the
    jaccard vectors; these indicate the proportion of pairwise
    similarity between clusters formed from subsets of the data.}
    \item{\code{size}:}{Object of class \code{"vector"}, only used for plotting.}
    \item{\code{iterations}:}{Object of class \code{"vector"},
      containing the number of iterations. Defaults to 100.}
    \item{\code{freq}:}{Object of class \code{"vector"}, containing the
      proportion of the data used for subsampling. }
  }
}
\section{Methods}{
  \describe{
    \item{ecdf}{\code{signature(x = "BenHur")}: Plot an empirical
      CDF. This can be used to help determine the number of clusters in
      the data. The most likely (e.g., most stable number) of clusters
      will have a CDF that is concentrated at or near one. See vignette
      for more information.}
    \item{hist}{\code{signature(x = "BenHur")}: Plot histograms for all
      clusters tested. The most likely (e.g., most stable number) of
      clusters will have a histogram in which the data are clustered at
      or near one. See vignette for more information.}
    \item{show}{\code{signature(object = "BenHur")}: Gives a nice
      summary. }
  }
}
\references{  A. Ben-Hur, A. Elisseeff and I. Guyon. A stability based
  method for discovering structure in clustered data. Pacific Symposium
  on Biocomputing, 2002.
  Smolkin, M. and Ghosh, D. (2003).  Cluster stability scores for
  microarray data in cancer studies.
  BMC Bioinformatics 4, 36 - 42.
}
\author{James W. MacDonald <jmacdon@u.washington.edu> }
\keyword{classes}

\name{clusterComp}
\docType{methods}
\alias{clusterComp}
\alias{do.clusterComp}
\alias{clusterComp-methods}
\alias{clusterComp,matrix-method}
\alias{clusterComp,ExpressionSet-method}

\title{Estimate Microarray Cluster Stability}
\description{
 This function estimates the stability of clustering solutions using
 microarray data. Currently only agglomerative hierarchical clustering
 is supported.
}
\usage{
\S4method{clusterComp}{ExpressionSet}(object, cl, seednum = NULL, B = 100,
sub.frac = 0.8, method = "ave", distmeth = "euclidean", adj.score = FALSE)
\S4method{clusterComp}{matrix}(object, cl, seednum = NULL, B = 100,
sub.frac = 0.8, method = "ave", distmeth = "euclidean", adj.score = FALSE)
}
\arguments{
  \item{object}{Either a matrix or \code{ExpressionSet}}
  \item{cl}{ The number of clusters. This may be estimated using \code{benhur}}
  \item{seednum}{A value to pass to \code{set.seed}, which will allow
    for exact reproducibility at a later date.}
  \item{B}{ The number of permutations.}
  \item{sub.frac}{The proportion of genes to use in each
    subsample. This value should be in the range of 0.75 - 0.85 for best
    results}
  \item{method}{ The linkage method to pass to \code{hclust}.  Valid values
    include "average", "centroid", "ward", "single", "mcquitty", or
    "median".}
  \item{distmeth}{The distance method to use. Valid values include
    "euclidean" and "pearson", where pearson implies 1-pearson correlation.}
  \item{adj.score}{Boolean. Should the stability scores be adjusted for
    cluster size? Defaults to \code{FALSE}.}
}
\details{
  This function estimates the stability of a clustering solution by
  repeatedly subsampling the data and comparing the cluster membership
  of the subsamples to the original clusters.
}
\value{
  The output from this function is an object of class \code{clusterComp}. See
  the \code{clusterComp-class} man page for more information.
}
\references{A. Ben-Hur, A. Elisseeff and I. Guyon. A stability based
  method for discovering structure in clustered data. Pacific Symposium
  on Biocomputing, 2002.
  Smolkin, M. and Ghosh, D. (2003).  Cluster stability scores
  for microarray data in cancer studies . BMC Bioinformatics 4, 36 - 42.}
\author{James W. MacDonald <jmacdon@u.washington.edu>}
\examples{
data(sample.ExpressionSet)
clusterComp(sample.ExpressionSet, 3)
}
\keyword{cluster }% at least one, from doc/KEYWORDS
